#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){if ($sysid eq "Windows"){read(STDIN,$data,$ENV{CONTENT_LENGTH});} else {$data=<STDIN>;}}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}

if ($data{subcat})
{
@data=();
if (!$data{start}){$start=0;} else {$start=$data{start};}
$argum=$data{cat};
$argum2=$data{subcat};
$data{cat}=~s/\+/ /g;
$data{cat}=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rw_rings.rid,rname,sum(hits) FROM rw_rings,rw_sites WHERE (caid=$data{subcat} AND rw_rings.rid=rw_sites.rid) GROUP BY rw_rings.rid ORDER BY rname");
while (($rid,$rname,$hits)=$sth->fetchrow)
{
	push (@data,"$hits\t$rname\t$rid");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT subcategory FROM rw_categories WHERE caid=$data{subcat}");
$data{subcat}=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
@data=sort ({$b<=>$a} @data);
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>20)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwbrowse.pl?cat=$argum&subcat=$argum2&start=$pstart\">PREVIOUS</a></font></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><font size=2><b>$icount webrings found</b></font></td>");
	if ($start*20+20<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><font size=2><a href=\"$cgi/rwbrowse.pl?cat=$argum&subcat=$argum2&start=$nstart\">NEXT</a></font></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><font size=2><b>$icount webrings found</b></font></td>");}
push (@footer,"</tr></table>");
if ($start*20+20>scalar(@data))
{
	$i=$start*20;
	while($i<scalar(@data))
	{
		$y=$i+1;
		($totalhits,$webr,$rid)=split("\t",$data[$i]);
		$fullrn=$webr;
		$fullrn=~s/_/ /g;
		push(@result,"$y. <a href=\"$cgi/rwgetnfo.pl?Webring=$rid\"><font size=\"2\"><b>$fullrn ($totalhits hits)</b></font></a><br>\n");
		$i++;
	}
}
else
{
	$i=$start*20;
	$last=$i+20;
	while($i<$last)
	{
		$y=$i+1;
		($totalhits,$webr,$rid)=split("\t",$data[$i]);
		$fullrn=$webr;
		$fullrn=~s/_/ /g;
		push(@result,"$y. <a href=\"$cgi/rwgetnfo.pl?Webring=$rid\"><font size=\"2\"><b>$fullrn ($totalhits hits)</b></font></a><br>\n");
		$i++;
	}
}
push(@result,"<font size=1>Nothing found</font>") if (!@result);
$result=join("",@result);
$result=qq~<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center><b><a href="$cgi/rwbrowse.pl?cat=$argum">CATEGORY</a>: $data{cat} : $data{subcat}</b></center></font></td></tr><tr><td>$result</td></tr>~ if ($result);
$footer="<tr><td>@footer</td></tr>" if (@footer);
&closedb;
open (F,"<$rwpath/template/browse.tpl");
@html=<F>;
close (F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
}
else
{
$argum=$data{cat};
$data{cat}=~s/\+/ /g;
$data{cat}=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
$sth=$dbh->query("LOCK TABLES rw_categories READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rw_categories.caid,subcategory,count(rid) FROM rw_categories,rw_rings WHERE (category='$data{cat}' AND rw_categories.caid=rw_rings.caid) GROUP BY subcategory ORDER BY subcategory");
while (($caid,$subcategory,$number)=$sth->fetchrow)
{
	$subcategory=~s/'/\\'/g;
	$hits{$subcategory}+=$number;
	$caid{$subcategory}=$caid;
	push (@categories,$subcategory);
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$i=0;
$total=@categories;
while($i<$total)
{
	$result.="<tr>";
	$temp=$categories[$i];
	$hits{$temp}=0 if (!$hits{$temp});
	$result.="<td><a href=\"$cgi/rwbrowse.pl?cat=$argum&subcat=$caid{$temp}\"><font size=2 color=white><b>$temp ($hits{$temp})</b></font></a></td>";
	$i++;
	if ($i<$total)
	{
	$temp=$categories[$i];
	$hits{$temp}=0 if (!$hits{$temp});
	$result.="<td><a href=\"$cgi/rwbrowse.pl?cat=$argum&subcat=$caid{$temp}\"><font size=2 color=white><b>$temp ($hits{$temp})</b></font></a></td>";
	$i++;
	}
	else
	{
	$result.="<td></td>";
	}
	$result.="</tr>";
}
$result=qq~<tr><td width="100%" bgcolor="#CECE00" colspan=2><font face="Arial" size="2" color="#000000"><center><b><a href="$ringworld">CATEGORY</a>: $data{cat}</b></center></font></td></tr>$result~ if ($result);
&closedb;
open (F,"<$rwpath/template/browse.tpl");
@html=<F>;
close (F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
}
sub closedb
{
$sth="";
$dbh="";
}
